#version 330 core

// vertex shader for waterfalls

layout(location = 0) in vec2 vertPos; //billboard coords (x,y)
layout(location = 1) in vec2 texUV;

out vec2 UV;
out vec4 aPos;

////////////////////////////////////////////

uniform mat4 MVP;

uniform vec3 wPos;
uniform vec3 wRad;



// see adagate-preplevel.adb (near end)

void main(){

	//not a mistake: vertPos.xy actually represents xz

	vec3 pos = wRad * vec3(vertPos.x, 0.0, vertPos.y) + wPos;

	aPos = vec4( pos, 1.0 );

	gl_Position = MVP * aPos;
	UV = texUV;
}


