#version 330 core

// vertex shader for stationary ztube object

layout(location = 0) in vec3 vertexPosition_modelspace;
layout(location = 1) in vec2 vertexUV;

out vec2 UV;

uniform mat4 MVP;
uniform vec3 wPos; //fixed object centroid

uniform float vang=0.0; //angle from vertical

const float onepi = 3.141592654;

// to generalize, make this a uniform:
const float angl = 0.125*onepi; //pi/8
//rotate down from vertical in Z- direction


void main(){

	// vertical pipe setup @ origin

	vec3 pos = vertexPosition_modelspace;

	vec3 nupos = pos;
	//rotate away from vertical (x fixed) toward Z-
	nupos.z= +cos(angl)*pos.z - sin(angl)*pos.y;
	nupos.y= +sin(angl)*pos.z + cos(angl)*pos.y;

	// ...move from origin to center
	nupos.x += wPos.x;
	nupos.y += wPos.y;
	nupos.z += wPos.z;

	gl_Position =  MVP * vec4(nupos,1.0);
	UV = vertexUV; 
}

