#version 330 core

// vertex shader for stationary ztube object

layout(location = 0) in vec3 vertexPosition_modelspace;
layout(location = 1) in vec2 vertexUV;

out vec2 UV;

uniform mat4 MVP;
uniform vec3 wPos; //fixed object centroid

uniform float vang=0.0; //angle from vertical


void main(){

	// vertical pipe setup @ origin

	vec3 pos = vertexPosition_modelspace;

	// ...move from origin to center
	pos.x += wPos.x;
	pos.y += wPos.y;
	pos.z += wPos.z;

	gl_Position =  MVP * vec4(pos,1.0);
	UV = vertexUV; 
}

